// vjb30030.cpp : AvP[VpNX̒`s܂B
//

#include "stdafx.h"
#include "vjb30030.h"
#include "OutputDevice.h"
#include "OutputFPD.h"
#include "OutputMOD.h"
#include "OutputCMT.h"
#include "OutputDAT.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEVICE_FPD		"FPD"
#define DEVICE_MOD		"MOD"
#define DEVICE_CMT		"CMT"
#define DEVICE_DAT		"DAT"

#define STATUS_READY		'N'
#define STATUS_EXECUTE		'1'
#define STATUS_NONCHECK		'2'
#define STATUS_EXECUTING	'3'
#define STATUS_IOERROR		'7'
#define STATUS_EXECUTEERROR	'8'

#define QF_LEN_DATE						14
#define QF_LEN_BAITAI_SHUBETSU_CODE		3
#define QF_LEN_BAITAI_SHIKIBETSU_CODE	6
#define QF_LEN_STATUS					1
#define QF_LEN_VOLUMELABEL				6

#define QF_POS_DATE						0
#define QF_POS_BAITAI_SHUBETSU_CODE		14
#define QF_POS_BAITAI_SHIKIBETSU_CODE	17
#define QF_POS_STATUS					23
#define QF_POS_VOLUMELABEL				24

// bZ[W
#define	MSG_KAKUNIN			"mFbZ[W"
#define MSG_ERROR			"G[bZ[W"

/////////////////////////////////////////////////////////////////////////////
// CVjb30030App

BEGIN_MESSAGE_MAP(CVjb30030App, CWinApp)
	//{{AFX_MSG_MAP(CVjb30030App)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVjb30030App NX̍\z

CVjb30030App::CVjb30030App()
{
	m_nRetCode = RC_NORMAL;
}

/////////////////////////////////////////////////////////////////////////////
// B CVjb30030App IuWFNg

CVjb30030App theApp;

CString g_sPathFPD;
CString g_sPathMOD;
CString g_sOutputDir;
CString g_sLogDir;

/////////////////////////////////////////////////////////////////////////////
// CVjb30030App NX̏

//
//	@\	F	CX^XJn
//
//		F	
//
//	Al	F	FALSE - vOI
//
//	@\F	vO{̂̏B
//
//	l	F	vOJnɃt[[NĂ΂B
//
BOOL CVjb30030App::InitInstance()
{
	m_nRetCode = Main(__argc, __argv);

	return FALSE;
}

//
//	@\	F	CX^XI
//
//		F	
//
//	Al	F	vOIR[h
//
//	@\F	vOIR[hԂB
//
//	l	F	vOIɃt[[NĂ΂B
//
int CVjb30030App::ExitInstance() 
{
	return m_nRetCode;
}

//
//	@\	F	O}̏o̓C
//
//		F	argc - p[^
//				argv - p[^e
//
//	Al	F	vOIR[h
//
//	@\F	O}̏o͂̃CsB
//
//	l	F	vOIɃt[[NĂ΂B
//
int CVjb30030App::Main(int argc, char *argv[])
{
	Queue *pQueue;
	COutputDevice *pOutputDevice;
	int nErrorCode;
	CString sErrorMsg;
	int nRetCode = RC_NORMAL;
	char cStatus;

	// p[^`FbN
	if (argc != 2)
		return RC_PARAMETER;

	// init@Cǂݍ
	ReadIniFile();

	// L[f[^擾
	pQueue = GetQueueData(argv[1]);

	// s܂̓xm`FbNsłȂ΃G[
	if (!(pQueue->cStatus == STATUS_EXECUTE || pQueue->cStatus == STATUS_NONCHECK))
		return RC_STATUS;

	// JnO
	WriteLogFile(pQueue, CreatePathName(g_sLogDir, "syuturyokustart"));

	// ԃR[hsɐݒ
	cStatus = pQueue->cStatus;
	ChangeStatus(pQueue, STATUS_EXECUTING);

	// o̓foCXʂ̃NX𐶐
	if (pQueue->sShubetsuCode == DEVICE_FPD)
		pOutputDevice = new COutputFPD;
	else if (pQueue->sShubetsuCode == DEVICE_MOD)
		pOutputDevice = new COutputMOD;
	else if (pQueue->sShubetsuCode == DEVICE_CMT)
		pOutputDevice = new COutputCMT;
	else if (pQueue->sShubetsuCode == DEVICE_DAT)
		pOutputDevice = new COutputDAT;
	else
		return RC_PARAMETER;

	// Rs[fBNg^t@C݃`FbN
	nRetCode = pOutputDevice->CheckDstFile(pQueue);

	// {[`FbN
	if (nRetCode == RC_NORMAL && cStatus != STATUS_NONCHECK)
		nRetCode = pOutputDevice->CheckVolumeName(pQueue);

	// t@Co
	if (nRetCode == RC_NORMAL)
		nRetCode = pOutputDevice->OutputFiles(pQueue);

	// ㏈
	switch (nRetCode) {
	case RC_NORMAL:
		pQueue->cStatus = '0';
		DeleteSrcFile(pQueue);
		NotifyChangeStatus();
		DispMessage(IDS_MSG_NORMAL_END, MB_OK, TRUE,
				(LPCTSTR)pQueue->sShubetsuCode, pQueue->sShikibetsuCode);
		break;
	case RC_VOLUMENAME:
		ChangeStatus(pQueue, STATUS_EXECUTEERROR);
		DispMessage(IDS_MSG_VOLLABEL_ERROR, MB_OK, TRUE, pQueue->sShubetsuCode);
		break;
	case RC_CANCEL:
		ChangeStatus(pQueue, STATUS_READY);
		break;
	case RC_MULTIFILEVOL:
		ChangeStatus(pQueue, STATUS_IOERROR);
		DispMessage(IDS_MSG_MULTIFILEVOL, MB_OK, TRUE);
		break;
	case RC_NODIRECTORY:
		ChangeStatus(pQueue, STATUS_IOERROR);
		DispMessage(IDS_MSG_NODIRECTORY, MB_OK, TRUE, pQueue->sShubetsuCode, pQueue->sShikibetsuCode);
		break;
	case RC_NOFILE:
		ChangeStatus(pQueue, STATUS_IOERROR);
		DispMessage(IDS_MSG_NOFILE, MB_OK, TRUE, pQueue->sShubetsuCode, pQueue->sShikibetsuCode);
		break;
	case RC_ILLEGALFILENAME:
		ChangeStatus(pQueue, STATUS_IOERROR);
		break;
	default:
		ChangeStatus(pQueue, STATUS_IOERROR);
		pOutputDevice->GetError(nErrorCode, sErrorMsg);
		if (nErrorCode == 0)
			DispMessage(IDS_MSG_IO_ERROR, MB_OK, TRUE, pQueue->sShubetsuCode);
		else
			DispMessage(IDS_MSG_IO_ERROR2, MB_OK, TRUE, pQueue->sShubetsuCode, -nErrorCode, sErrorMsg);
		break;
	}

	// }̏o̓NXJ
	delete pOutputDevice;

	// IO
	WriteLogFile(pQueue, CreatePathName(g_sLogDir, "syuturyokuend"));

	// L[J
	delete pQueue;

	return nRetCode;
}

//
//	@\	F	init@Cǂݍݏ
//
//		F	
//
//	Al	F	
//
//	@\F	init@CKvȏǂݍށB
//
//	l	F	
//
void CVjb30030App::ReadIniFile()
{
	// INIt@CL[t@CfBNg擾
	m_sQueueDir = GetIniData("Queue", "Dir", "");

	// FPD̃pX擾
	g_sPathFPD = GetIniData("Device", "FPD", "A:\\");

	// MOD̃pX擾
	g_sPathMOD = GetIniData("Device", "MOD", "M:\\");

	// o̓t@CfBNg擾
	g_sOutputDir = GetIniData("OutputFile", "Dir", "Z:\\");

	// Ot@CfBNg擾
	g_sLogDir = GetIniData("LogFile", "Dir", "");
}

//
//	@\	F	L[擾
//
//		F	
//
//	Al	F	
//
//	@\F	L[t@CL[쐬B
//
//	l	F	
//
Queue *CVjb30030App::GetQueueData(CString sFileName)
{
	Queue *pQueue = new Queue;

	// L[t@Cep[^擾
	pQueue->sFileName = sFileName;
	pQueue->sShubetsuCode = sFileName.Mid(QF_POS_BAITAI_SHUBETSU_CODE, QF_LEN_BAITAI_SHUBETSU_CODE);
	pQueue->sShikibetsuCode = sFileName.Mid(QF_POS_BAITAI_SHIKIBETSU_CODE, QF_LEN_BAITAI_SHIKIBETSU_CODE);
	pQueue->sVolLabel = sFileName.Mid(QF_POS_VOLUMELABEL);
	pQueue->sCreateDate = sFileName.Left(QF_LEN_DATE);
	pQueue->cStatus = sFileName[QF_POS_STATUS];

	return pQueue;
}

//
//	@\	F@ԃR[hύX
//
//		F	pQueue - L[
//				status - ԃR[h
//
//	Al	F	
//
//	@\F	L[t@C̏ԃR[hύXB
//
//	l	F	
//
void CVjb30030App::ChangeStatus(Queue *pQueue, char status)
{
	CString sOldFileName, sNewFileName;

	// L[t@C̃pX擾
	sOldFileName = CreatePathName(m_sQueueDir, pQueue->sFileName);

	// ԃR[hύX
	pQueue->sFileName.SetAt(QF_POS_STATUS, status);
	pQueue->cStatus = status;

	// ύX̃L[t@C̃pX擾
	sNewFileName = CreatePathName(m_sQueueDir, pQueue->sFileName);

	// t@CύX
	MoveFile(sOldFileName, sNewFileName);

	// O}̏o͊ǗvOɒʒm
	NotifyChangeStatus();
}

//
//	@\	F@o͌t@C폜
//
//		F	pQueue - L[
//
//	Al	F	
//
//	@\F	o͂̏It@C폜B
//
//	l	F	
//
void CVjb30030App::DeleteSrcFile(Queue *pQueue)
{
	// L[t@C̍폜
	DeleteFile(CreatePathName(m_sQueueDir, pQueue->sFileName));

	// Rs[fBNgAt@C폜
	DeleteDirectory(CreatePathName(g_sOutputDir, pQueue->sShikibetsuCode + pQueue->sVolLabel.SpanExcluding(",")), TRUE);
}

//
//	@\	F@L[t@CύXʒm
//
//		F	
//
//	Al	F	
//
//	@\F	O}̊ǗvOɃL[t@C̕ύXʒmB
//
//	l	F	
//
void CVjb30030App::NotifyChangeStatus()
{
	CWnd *pWnd;

	pWnd = CWnd::FindWindow(NULL, "}̏o͎w(vjb30020)");
	if (pWnd != NULL)
		pWnd->SendMessage(WM_TIMER, 1, 0);
}

//
//	@\	F	Ot@Cݏ
//
//		F	pParam - ̓p[^
//				pLogFile - Ot@C
//
//	Al	F	
//
//	@\F	w肳ꂽOt@CɃOށB
//
//	l	F	
//
void CVjb30030App::WriteLogFile(Queue *pQueue, LPCTSTR pLogFile)
{
	CStdioFile file;

	// Ot@CI[v
	if (file.Open(pLogFile, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite | CFile::shareDenyWrite)) {
		SYSTEMTIME st;
		CString str;

		// ݎ擾
		GetLocalTime(&st);

		// ÕtH[}bg
		str.Format("%04d/%02d/%02d %02d:%02d:%02d,%s/%s/%s %s:%s:%s,%s,%s,%s,%c\n",
				st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond,
				pQueue->sCreateDate.Mid(0, 4),
				pQueue->sCreateDate.Mid(4, 2),
				pQueue->sCreateDate.Mid(6, 2),
				pQueue->sCreateDate.Mid(8, 2),
				pQueue->sCreateDate.Mid(10, 2),
				pQueue->sCreateDate.Mid(12, 2),
				pQueue->sShubetsuCode,
				pQueue->sShikibetsuCode,
				pQueue->sVolLabel,
				pQueue->cStatus);

		// ŏIʒuɒǉ
		file.Seek(0, CFile::end);
		file.WriteString(str);
		file.Close();
	}
}
